source: installer/opengnsys_update.sh @ 8068b82

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacion
Last change on this file since 8068b82 was 506c670, checked in by Ramón M. Gómez <ramongomez@…>, 6 years ago

#914: Installer and updater check HTTP and HTTPS connections to avoid proxy configuration errors.

  • Property mode set to 100755
File size: 42.2 KB
Line 
1#!/bin/bash
2#/**
3#@file    opengnsys_update.sh
4#@brief   Script actualización de OpenGnsys
5#@version 0.9 - basado en opengnsys_installer.sh
6#@author  Ramón Gómez - ETSII Univ. Sevilla
7#@date    2010/01/27
8#@version 1.0 - adaptación a OpenGnSys 1.0
9#@author  Ramón Gómez - ETSII Univ. Sevilla
10#@date    2011/03/02
11#@version 1.0.1 - control de auto actualización del script
12#@author  Ramón Gómez - ETSII Univ. Sevilla
13#@date    2011/05/17
14#@version 1.0.2a - obtiene valor de dirección IP por defecto
15#@author  Ramón Gómez - ETSII Univ. Sevilla
16#@date    2012/01/18
17#@version 1.0.3 - Compatibilidad con Debian y auto configuración de acceso a BD.
18#@author  Ramón Gómez - ETSII Univ. Sevilla
19#@date    2012/03/12
20#@version 1.0.4 - Detector de distribución y compatibilidad con CentOS.
21#@author  Ramón Gómez - ETSII Univ. Sevilla
22#@date    2012/05/04
23#@version 1.0.5 - Actualizar BD en la misma versión, compatibilidad con Fedora (systemd) y configuración de Rsync.
24#@author  Ramón Gómez - ETSII Univ. Sevilla
25#@date    2014/04/03
26#@version 1.0.6 - Redefinir URLs de ficheros de configuración usando HTTPS.
27#@author  Ramón Gómez - ETSII Univ. Sevilla
28#@date    2015/03/12
29#@version 1.1.0 - Instalación de API REST y configuración de zona horaria.
30#@author  Ramón Gómez - ETSII Univ. Sevilla
31#@date    2015/11/09
32#*/
33
34
35####  AVISO: NO EDITAR variables de configuración.
36####  WARNING: DO NOT EDIT configuration variables.
37INSTALL_TARGET=/opt/opengnsys           # Directorio de instalación
38PATH=$PATH:$INSTALL_TARGET/bin
39OPENGNSYS_CLIENTUSER="opengnsys"        # Usuario Samba
40
41
42# Sólo ejecutable por usuario root
43if [ "$(whoami)" != 'root' ]; then
44        echo "ERROR: this program must run under root privileges!!"
45        exit 1
46fi
47# Error si OpenGnsys no está instalado (no existe el directorio del proyecto)
48if [ ! -d $INSTALL_TARGET ]; then
49        echo "ERROR: OpenGnsys is not installed, cannot update!!"
50        exit 1
51fi
52# Cargar configuración de acceso a la base de datos.
53if [ -r $INSTALL_TARGET/etc/ogAdmServer.cfg ]; then
54        source $INSTALL_TARGET/etc/ogAdmServer.cfg
55elif [ -r $INSTALL_TARGET/etc/ogAdmAgent.cfg ]; then
56        source $INSTALL_TARGET/etc/ogAdmAgent.cfg
57fi
58OPENGNSYS_DATABASE=${OPENGNSYS_DATABASE:-"$CATALOG"}            # Base de datos
59OPENGNSYS_DBUSER=${OPENGNSYS_DBUSER:-"$USUARIO"}                # Usuario de acceso
60OPENGNSYS_DBPASSWORD=${OPENGNSYS_DBPASSWORD:-"$PASSWORD"}       # Clave del usuario
61if [ -z "$OPENGNSYS_DATABASE" -o -z "$OPENGNSYS_DBUSER" -o -z "$OPENGNSYS_DBPASSWORD" ]; then
62        echo "ERROR: set OPENGNSYS_DATABASE, OPENGNSYS_DBUSER and OPENGNSYS_DBPASSWORD"
63        echo "       variables, and run this script again."
64        exit 1
65fi
66
67# Comprobar si se ha descargado el paquete comprimido (REMOTE=0) o sólo el instalador (REMOTE=1).
68PROGRAMDIR=$(readlink -e $(dirname "$0"))
69PROGRAMNAME=$(basename "$0")
70OPENGNSYS_SERVER="opengnsys.es"
71if [ -d "$PROGRAMDIR/../installer" ]; then
72        REMOTE=0
73else
74        REMOTE=1
75fi
76BRANCH="devel"
77CODE_URL="https://codeload.github.com/opengnsys/OpenGnsys/zip/$BRANCH"
78API_URL="https://api.github.com/repos/opengnsys/OpenGnsys/branches/$BRANCH"
79RAW_URL="https://raw.githubusercontent.com/opengnsys/OpenGnsys/$BRANCH"
80
81WORKDIR=/tmp/opengnsys_update
82mkdir -p $WORKDIR
83
84# Registro de incidencias.
85OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
86LOG_FILE=/tmp/$(basename $OGLOGFILE)
87
88
89
90#####################################################################
91####### Algunas funciones útiles de propósito general:
92#####################################################################
93
94# Generar variables de configuración del actualizador
95# Variables globales:
96# - OSDISTRIB - distribución Linux
97# - DEPENDENCIES - array de dependencias que deben estar instaladas
98# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKG - comandos para gestión de paquetes
99# - APACHECFGDIR, APACHESERV, PHPFPMSERV, DHCPSERV, INETDCFGDIR - configuración y servicios
100
101function autoConfigure()
102{
103        local service
104
105        # Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
106        if [ -f /etc/os-release ]; then
107                source /etc/os-release
108                OSDISTRIB="$ID"
109                OSVERSION="$VERSION_ID"
110        else
111                OSDISTRIB=$(lsb_release -is 2>/dev/null)
112                OSVERSION=$(lsb_release -rs 2>/dev/null)
113        fi
114        # Convertir distribución a minúsculas y obtener solo el 1er número de versión.
115        OSDISTRIB="${OSDISTRIB,,}"
116        OSVERSION="${OSVERSION%%.*}"
117
118        # Configuración según la distribución de Linux.
119        if [ -f /etc/debian_version ]; then
120                # Distribución basada en paquetes Deb.
121                DEPENDENCIES=( curl rsync btrfs-tools procps arp-scan realpath php-curl gettext moreutils jq wakeonlan udpcast libev-dev libjansson-dev shim-signed grub-efi-amd64-signed php-fpm )
122                # Paquete correcto para realpath.
123                [ -z "$(apt-cache pkgnames realpath)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//realpath/coreutils} )
124                UPDATEPKGLIST="add-apt-repository -y ppa:ondrej/php; apt-get update"
125                INSTALLPKGS="apt-get -y install"
126                DELETEPKGS="apt-get -y purge"
127                CHECKPKG="dpkg -s \$package 2>/dev/null | grep -q \"Status: install ok\""
128                if which service &>/dev/null; then
129                        STARTSERVICE="eval service \$service restart"
130                        STOPSERVICE="eval service \$service stop"
131                        SERVICESTATUS="eval service \$service status"
132                else
133                        STARTSERVICE="eval /etc/init.d/\$service restart"
134                        STOPSERVICE="eval /etc/init.d/\$service stop"
135                        SERVICESTATUS="eval /etc/init.d/\$service status"
136                fi
137                ENABLESERVICE="eval update-rc.d \$service defaults"
138                APACHEENABLEMODS="ssl rewrite proxy_fcgi fastcgi actions alias"
139                APACHEDISABLEMODS="php"
140                APACHEUSER="www-data"
141                APACHEGROUP="www-data"
142                PHPFPMSERV="php-fpm"
143                INETDCFGDIR=/etc/xinetd.d
144        elif [ -f /etc/redhat-release ]; then
145                # Distribución basada en paquetes rpm.
146                DEPENDENCIES=( curl rsync btrfs-progs procps-ng arp-scan gettext moreutils jq net-tools udpcast libev-devel shim-x64 grub2-efi-x64 grub2-efi-x64-modules )
147                # Repositorios para PHP 7 en CentOS.
148                [ "$OSDISTRIB" == "centos" ] && UPDATEPKGLIST="yum update -y https://dl.fedoraproject.org/pub/epel/epel-release-latest-$OSVERSION.noarch.rpm http://rpms.remirepo.net/enterprise/remi-release-$OSVERSION.rpm"
149                INSTALLPKGS="yum install -y"
150                DELETEPKGS="yum remove -y"
151                CHECKPKG="rpm -q --quiet \$package"
152                if which systemctl &>/dev/null; then
153                        STARTSERVICE="eval systemctl restart \$service.service"
154                        STOPSERVICE="eval systemctl stop \$service.service"
155                        ENABLESERVICE="eval systemctl enable \$service.service"
156                        SERVICESTATUS="eval systemctl status \$service.service"
157                else
158                        STARTSERVICE="eval service \$service restart"
159                        STOPSERVICE="eval service \$service stop"
160                        ENABLESERVICE="eval chkconfig \$service on"
161                        SERVICESTATUS="eval service \$service status"
162                fi
163                APACHEUSER="apache"
164                APACHEGROUP="apache"
165                PHPFPMSERV="php-fpm"
166                INETDCFGDIR=/etc/xinetd.d
167        else
168                # Otras distribuciones.
169                :
170        fi
171        for service in apache2 httpd; do
172                [ -d "/etc/$service" ] && APACHECFGDIR="/etc/$service"
173                if $SERVICESTATUS &>/dev/null; then APACHESERV="$service"; fi
174        done
175        for service in dhcpd dhcpd3-server isc-dhcp-server; do
176                if $SERVICESTATUS &>/dev/null; then DHCPSERV="$service"; fi
177        done
178}
179
180
181# Comprobar auto-actualización.
182function checkAutoUpdate()
183{
184        local update=0
185
186        # Actaulizar el script si ha cambiado o no existe el original.
187        if [ $REMOTE -eq 1 ]; then
188                curl -s $RAW_URL/installer/$PROGRAMNAME -o $PROGRAMNAME
189                chmod +x $PROGRAMNAME
190                if ! diff -q $PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
191                        mv $PROGRAMNAME $INSTALL_TARGET/lib
192                        update=1
193                else
194                        rm -f $PROGRAMNAME
195                fi
196        else
197                if ! diff -q $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
198                        cp -a $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib
199                        update=1
200                fi
201        fi
202
203        return $update
204}
205
206
207function getDateTime()
208{
209        date "+%Y%m%d-%H%M%S"
210}
211
212# Escribe a fichero y muestra por pantalla
213function echoAndLog()
214{
215        echo "$1"
216        DATETIME=`getDateTime`
217        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
218}
219
220function errorAndLog()
221{
222        echo "ERROR: $1"
223        DATETIME=`getDateTime`
224        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
225}
226
227# Escribe a fichero y muestra mensaje de aviso
228function warningAndLog()
229{
230        local DATETIME=`getDateTime`
231        echo "Warning: $1"
232        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
233}
234
235
236#####################################################################
237####### Funciones de copia de seguridad y restauración de ficheros
238#####################################################################
239
240# Hace un backup del fichero pasado por parámetro
241# deja un -last y uno para el día
242function backupFile()
243{
244        if [ $# -ne 1 ]; then
245                errorAndLog "${FUNCNAME}(): invalid number of parameters"
246                exit 1
247        fi
248
249        local fichero=$1
250        local fecha=`date +%Y%m%d`
251
252        if [ ! -f $fichero ]; then
253                warningAndLog "${FUNCNAME}(): file $fichero doesn't exists"
254                return 1
255        fi
256
257        echoAndLog "${FUNCNAME}(): Making $fichero back-up"
258
259        # realiza una copia de la última configuración como last
260        cp -a $fichero "${fichero}-LAST"
261
262        # si para el día no hay backup lo hace, sino no
263        if [ ! -f "${fichero}-${fecha}" ]; then
264                cp -a $fichero "${fichero}-${fecha}"
265        fi
266}
267
268# Restaura un fichero desde su copia de seguridad
269function restoreFile()
270{
271        if [ $# -ne 1 ]; then
272                errorAndLog "${FUNCNAME}(): invalid number of parameters"
273                exit 1
274        fi
275
276        local fichero=$1
277
278        echoAndLog "${FUNCNAME}(): restoring file $fichero"
279        if [ -f "${fichero}-LAST" ]; then
280                cp -a "$fichero-LAST" "$fichero"
281        fi
282}
283
284
285#####################################################################
286####### Funciones de acceso a base de datos
287#####################################################################
288
289# Actualizar la base datos
290function importSqlFile()
291{
292        if [ $# -ne 4 ]; then
293                errorAndLog "${FNCNAME}(): invalid number of parameters"
294                exit 1
295        fi
296
297        local dbuser="$1"
298        local dbpassword="$2"
299        local database="$3"
300        local sqlfile="$4"
301        local tmpfile=$(mktemp)
302        local mycnf=/tmp/.my.cnf.$$
303        local status
304        local APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
305
306        if [ ! -r $sqlfile ]; then
307                errorAndLog "${FUNCNAME}(): Unable to read $sqlfile!!"
308                return 1
309        fi
310
311        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
312        chmod 600 $tmpfile
313        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
314            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
315            -e "s/APIKEY/$APIKEY/g" -e "s/REPOKEY/$REPOKEY/g" $sqlfile > $tmpfile
316        # Componer fichero con credenciales de conexión. 
317        touch $mycnf
318        chmod 600 $mycnf
319        cat << EOT > $mycnf
320[client]
321user=$dbuser
322password=$dbpassword
323EOT
324        # Ejecutar actualización y borrar fichero de credenciales.
325        mysql --defaults-extra-file=$mycnf --default-character-set=utf8 -D "$database" < $tmpfile
326        status=$?
327        rm -f $mycnf $tmpfile
328        if [ $status -ne 0 ]; then
329                errorAndLog "${FUNCNAME}(): error importing $sqlfile in database $database"
330                return 1
331        fi
332        echoAndLog "${FUNCNAME}(): file imported to database $database"
333        return 0
334}
335
336# Comprobar configuración de MySQL y recomendar cambios necesarios.
337function checkMysqlConfig()
338{
339        if [ $# -ne 2 ]; then
340                errorAndLog "${FNCNAME}(): invalid number of parameters"
341                exit 1
342        fi
343
344        local dbuser="$1"
345        local dbpassword="$2"
346        local mycnf=/tmp/.my.cnf.$$
347
348        echoAndLog "${FUNCNAME}(): checking MySQL configuration"
349        touch $mycnf
350        cat << EOT > $mycnf
351[client]
352user=$dbuser
353password=$dbpassword
354EOT
355        # Check if scheduler is active.
356        if [ "$(mysql --defaults-extra-file=$mycnf -Nse 'SELECT @@GLOBAL.event_scheduler;')" = "OFF" ]; then
357                MYSQLCONFIG="SET GLOBAL event_scheduler = ON; "
358        fi
359        rm -f $mycnf
360
361        echoAndLog "${FUNCNAME}(): MySQL configuration has checked"
362        return 0
363}
364
365#####################################################################
366####### Funciones de instalación de paquetes
367#####################################################################
368
369# Instalar las deependencias necesarias para el actualizador.
370function installDependencies()
371{
372        local package
373
374        # Comprobar si hay que actualizar PHP 5 a PHP 7.
375        eval $UPDATEPKGLIST
376        if [ -f /etc/debian_version ]; then
377                # Basado en paquetes Deb.
378                PHP7VERSION=$(apt-cache pkgnames php7 2>/dev/null | sort | head -1)
379                PHPFPMSERV="${PHP7VERSION}-fpm"
380                PHP5PKGS=( $(dpkg -l | awk '$2~/^php5/ {print $2}') )
381                if [ -n "$PHP5PKGS" ]; then
382                        $DELETEPKGS ${PHP5PKGS[@]}
383                        PHP5PKGS[0]="$PHP7VERSION"
384                        INSTALLDEPS=${PHP5PKGS[@]//php5*-/${PHP7VERSION}-}
385                fi
386        fi
387        if [ "$OSDISTRIB" == "centos" ]; then
388                PHP7VERSION=$(yum list -q php7\* 2>/dev/null | awk -F. '/^php/ {print $1; exit;}')
389                PHPFPMSERV="${PHP7VERSION}-${PHPFPMSERV}"
390                PHP5PKGS=( $(yum list installed | awk '$1~/^php/ && $2~/^5\./ {sub(/\..*$/, "", $1); print $1}') )
391                if [ -n "$PHP5PKGS" ]; then
392                        $DELETEPKGS ${PHP5PKGS[@]}
393                        PHP5PKGS[0]="$PHP7VERSION-php"
394                        INSTALLDEPS=${PHP5PKGS[@]//php-/${PHP7VERSION}-php}
395                fi
396        fi
397
398        if [ $# = 0 ]; then
399                echoAndLog "${FUNCNAME}(): no dependencies are needed"
400        else
401                while [ $# -gt 0 ]; do
402                        package="${1/php/$PHP7VERSION}"
403                        eval $CHECKPKG || INSTALLDEPS="$INSTALLDEPS $package"
404                        shift
405                done
406                if [ -n "$INSTALLDEPS" ]; then
407                        $INSTALLPKGS $INSTALLDEPS
408                        if [ $? -ne 0 ]; then
409                                errorAndLog "${FUNCNAME}(): cannot install some dependencies: $INSTALLDEPS"
410                                return 1
411                        fi
412                fi
413        fi
414}
415
416
417#####################################################################
418####### Funciones para descargar código
419#####################################################################
420
421function downloadCode()
422{
423        if [ $# -ne 1 ]; then
424                errorAndLog "${FUNCNAME}(): invalid number of parameters"
425                exit 1
426        fi
427
428        local url="$1"
429
430        echoAndLog "${FUNCNAME}(): downloading code..."
431
432        curl "$url" -o opengnsys.zip && \
433                unzip -qo opengnsys.zip && \
434                rm -fr opengnsys && \
435                mv "OpenGnsys-$BRANCH" opengnsys
436        if [ $? -ne 0 ]; then
437                errorAndLog "${FUNCNAME}(): error getting code from ${url}, verify your user and password"
438                return 1
439        fi
440        rm -f opengnsys.zip
441        echoAndLog "${FUNCNAME}(): code was downloaded"
442        return 0
443}
444
445
446############################################################
447###  Detectar red
448############################################################
449
450# Comprobar si existe conexión.
451function checkNetworkConnection()
452{
453        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"opengnsys.es"}
454        if which curl &>/dev/null; then
455                curl --connect-timeout 10 -s "https://$OPENGNSYS_SERVER" -o /dev/null && \
456                        curl --connect-timeout 10 -s "http://$OPENGNSYS_SERVER" -o /dev/null
457        elif which wget &>/dev/null; then
458                wget --spider -q "https://$OPENGNSYS_SERVER" && \
459                        wget --spider -q "http://$OPENGNSYS_SERVER"
460        else
461                echoAndLog "${FUNCNAME}(): Cannot execute \"wget\" nor \"curl\"."
462                return 1
463        fi
464}
465
466# Comprobar si la versión es anterior a la actual.
467function checkVersion()
468{
469        local PRE
470
471        # Obtener versión actual y versión a actualizar.
472        [ -f $INSTALL_TARGET/doc/VERSION.txt ] && OLDVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt 2>/dev/null)
473        [ -f $INSTALL_TARGET/doc/VERSION.json ] && OLDVERSION=$(jq -r '.version' $INSTALL_TARGET/doc/VERSION.json 2>/dev/null)
474        if [ $REMOTE -eq 1 ]; then
475                NEWVERSION=$(curl -s $RAW_URL/doc/VERSION.json 2>/dev/null | jq -r '.version')
476        else
477                NEWVERSION=$(jq -r '.version' $PROGRAMDIR/../doc/VERSION.json 2>/dev/null)
478        fi
479        [[ "$NEWVERSION" =~ pre ]] && PRE=1
480
481        # Comparar versiones.
482        [[ "$NEWVERSION" < "${OLDVERSION/pre/}" ]] && return 1
483        [ "${NEWVERSION/pre/}" == "$OLDVERSION" -a "$PRE" == "1" ] && return 1
484
485        return 0
486}
487
488# Obtener los parámetros de red del servidor.
489function getNetworkSettings()
490{
491        # Variables globales definidas:
492        # - SERVERIP:   IP local de la interfaz por defecto.
493
494        local DEVICES
495        local dev
496
497        echoAndLog "${FUNCNAME}(): Detecting network parameters"
498        SERVERIP="$ServidorAdm"
499        DEVICES="$(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}')"
500        for dev in $DEVICES; do
501                [ -z "$SERVERIP" ] && SERVERIP=$(ip -o addr show dev $dev | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4); exit;}')
502        done
503}
504
505
506#####################################################################
507####### Funciones específicas de la instalación de Opengnsys
508#####################################################################
509
510# Actualizar cliente OpenGnsys.
511function updateClientFiles()
512{
513        local ENGINECFG=$INSTALL_TARGET/client/etc/engine.cfg
514
515        # Actualizar ficheros del cliente.
516        backupFile $ENGINECFG
517        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Client files"
518        rsync -irplt $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
519        if [ $? -ne 0 ]; then
520                errorAndLog "${FUNCNAME}(): error while updating client structure"
521                exit 1
522        fi
523
524        # Actualizar librerías del motor de clonación.
525        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Cloning Engine files"
526        rsync -irplt $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
527        if [ $? -ne 0 ]; then
528                errorAndLog "${FUNCNAME}(): error while updating engine files"
529                exit 1
530        fi
531        # Actualizar fichero de configuración del motor de clonación.
532        if ! grep -q "^TZ" $ENGINECFG; then
533                TZ=$(timedatectl status | awk -F"[:()]" '/Time.*zone/ {print $2}')
534                cat << EOT >> $ENGINECFG
535# OpenGnsys Server timezone.
536TZ="${TZ// /}"
537EOT
538        fi
539        if ! diff -q ${ENGINECFG}{,-LAST} &>/dev/null; then
540                NEWFILES="$NEWFILES $ENGINECFG"
541        else
542                rm -f ${ENGINECFG}-LAST
543        fi
544        # Obtener URL para descargas adicionales.
545        DOWNLOADURL=$(oglivecli config download-url 2>/dev/null)
546        DOWNLOADURL=${DOWNLOADURL:-"https://$OPENGNSYS_SERVER/trac/downloads"}
547
548        echoAndLog "${FUNCNAME}(): client files successfully updated"
549}
550
551# Crear certificado para la firma de cargadores de arranque, si es necesario.
552function createCerts ()
553{
554        local SSLCFGDIR=$INSTALL_TARGET/client/etc/ssl
555        mkdir -p $SSLCFGDIR/{certs,private}
556        if [ ! -f $SSLCFGDIR/private/opengnsys.key ]; then
557                echoAndLog "${FUNCNAME}(): creating certificate files"
558                openssl req -new -x509 -newkey rsa:2048 -keyout $SSLCFGDIR/private/opengnsys.key -out $SSLCFGDIR/certs/opengnsys.crt -nodes -days 3650 -subj "/CN=OpenGnsys/"
559                openssl x509 -in $SSLCFGDIR/certs/opengnsys.crt -out $SSLCFGDIR/certs/opengnsys.cer -outform DER
560                echoAndLog "${FUNCNAME}(): certificate successfully created"
561        fi
562}
563
564# Configurar HTTPS y exportar usuario y grupo del servicio Apache.
565function apacheConfiguration ()
566{
567        local config template module socketfile
568
569        # Avtivar PHP-FPM.
570        echoAndLog "${FUNCNAME}(): configuring PHP-FPM"
571        service=$PHPFPMSERV
572        $ENABLESERVICE; $STARTSERVICE
573
574        # Activar módulos de Apache.
575        if [ -e $APACHECFGDIR/sites-available/opengnsys.conf ]; then
576                echoAndLog "${FUNCNAME}(): Configuring Apache modules"
577                a2ensite default-ssl
578                for module in $APACHEENABLEMODS; do a2enmod -q "$module"; done
579                for module in $APACHEDISABLEMODS; do a2dismod -q "${module//PHP7VERSION}"; done
580                a2ensite opengnsys
581        elif [ -e $APACHECFGDIR/conf.modules.d ]; then
582                echoAndLog "${FUNCNAME}(): Configuring Apache modules"
583                sed -i '/rewrite/s/^#//' $APACHECFGDIR/*.conf
584        fi
585        # Elegir plantilla según versión de Apache.
586        if [ -n "$(apachectl -v | grep "2\.[0-2]")" ]; then
587               template=$WORKDIR/opengnsys/server/etc/apache-prev2.4.conf.tmpl > $config
588        else
589               template=$WORKDIR/opengnsys/server/etc/apache.conf.tmpl
590        fi
591        sockfile=$(find /run/php -name "php*.sock" -type s -print 2>/dev/null | tail -1)
592        # Actualizar configuración de Apache a partir de fichero de plantilla.
593        for config in $APACHECFGDIR/{,sites-available/}opengnsys.conf; do
594                if [ -e $config ]; then
595                        if [ -n "$sockfile" ]; then
596                                sed -e "s,CONSOLEDIR,$INSTALL_TARGET/www,g; s,proxy:fcgi:.*,proxy:unix:${sockfile%% *}|fcgi://localhost\",g" $template > $config
597                        else
598                                sed -e "s,CONSOLEDIR,$INSTALL_TARGET/www,g" $template > $config
599                        fi
600                fi
601        done
602
603        # Reiniciar Apache.
604        service=$APACHESERV; $STARTSERVICE
605
606        # Variables de ejecución de Apache.
607        # - APACHE_RUN_USER
608        # - APACHE_RUN_GROUP
609        if [ -f $APACHECFGDIR/envvars ]; then
610                source $APACHECFGDIR/envvars
611        fi
612        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
613        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
614}
615
616# Configurar servicio Rsync.
617function rsyncConfigure()
618{
619        local service
620
621        # Configurar acceso a Rsync.
622        if [ ! -f /etc/rsyncd.conf ]; then
623                echoAndLog "${FUNCNAME}(): Configuring Rsync service"
624                NEWFILES="$NEWFILES /etc/rsyncd.conf"
625                sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENTUSER/g" \
626                    $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > /etc/rsyncd.conf
627                # Habilitar Rsync.
628                if [ -f /etc/default/rsync ]; then
629                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
630                fi
631                if [ -f $INETDCFGDIR/rsync ]; then
632                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
633                else
634                        cat << EOT > $INETDCFGDIR/rsync
635service rsync
636{
637        disable = no
638        socket_type = stream
639        wait = no
640        user = root
641        server = $(which rsync)
642        server_args = --daemon
643        log_on_failure += USERID
644        flags = IPv6
645}
646EOT
647                fi
648                # Activar e iniciar Rsync.
649                service="rsync"  $ENABLESERVICE
650                service="xinetd"
651                $ENABLESERVICE; $STARTSERVICE
652        fi
653}
654
655# Copiar ficheros del OpenGnsys Web Console.
656function updateWebFiles()
657{
658        local ERRCODE COMPATDIR f
659
660        echoAndLog "${FUNCNAME}(): Updating web files..."
661
662        # Copiar los ficheros nuevos conservando el archivo de configuración de acceso.
663        backupFile $INSTALL_TARGET/www/controlacceso.php
664        mv $INSTALL_TARGET/www $INSTALL_TARGET/WebConsole
665        rsync -irplt $WORKDIR/opengnsys/admin/WebConsole $INSTALL_TARGET
666        ERRCODE=$?
667        mv $INSTALL_TARGET/WebConsole $INSTALL_TARGET/www
668        rm -fr $INSTALL_TARGET/www/xajax
669        unzip -o $WORKDIR/opengnsys/admin/slim-2.6.1.zip -d $INSTALL_TARGET/www/rest
670        unzip -o $WORKDIR/opengnsys/admin/swagger-ui-2.2.5.zip -d $INSTALL_TARGET/www/rest
671        if [ $ERRCODE != 0 ]; then
672                errorAndLog "${FUNCNAME}(): Error updating web files."
673                exit 1
674        fi
675        restoreFile $INSTALL_TARGET/www/controlacceso.php
676
677        # Cambiar acceso a protocolo HTTPS.
678        if grep -q "http://" $INSTALL_TARGET/www/controlacceso.php 2>/dev/null; then
679                echoAndLog "${FUNCNAME}(): updating web access file"
680                perl -pi -e 's!http://!https://!g' $INSTALL_TARGET/www/controlacceso.php
681                NEWFILES="$NEWFILES $INSTALL_TARGET/www/controlacceso.php"
682        fi
683
684        # Compatibilidad con dispositivos móviles.
685        COMPATDIR="$INSTALL_TARGET/www/principal"
686        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
687                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
688        done
689        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
690        # Acceso al manual de usuario
691        ln -fs ../doc/userManual $INSTALL_TARGET/www/userManual
692        # Fichero de log de la API REST.
693        touch $INSTALL_TARGET/log/{ogagent,rest,remotepc}.log
694
695        echoAndLog "${FUNCNAME}(): Web files successfully updated"
696}
697
698# Copiar ficheros en la zona de descargas de OpenGnsys Web Console.
699function updateDownloadableFiles()
700{
701        local FILENAME=ogagentpkgs-$NEWVERSION.tar.gz
702        local TARGETFILE=$WORKDIR/$FILENAME
703
704        # Descargar archivo comprimido, si es necesario.
705        if [ -s $PROGRAMDIR/$FILENAME ]; then
706                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
707                mv $PROGRAMDIR/$FILENAME $TARGETFILE
708        else
709                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
710                curl $DOWNLOADURL/$FILENAME -o $TARGETFILE
711        fi
712        if [ ! -s $TARGETFILE ]; then
713                errorAndLog "${FUNCNAME}(): Cannot download $FILENAME"
714                return 1
715        fi
716
717        # Descomprimir fichero en zona de descargas.
718        tar xvzf $TARGETFILE -C $INSTALL_TARGET/www/descargas
719        if [ $? != 0 ]; then
720                errorAndLog "${FUNCNAME}(): Error uncompressing archive $FILENAME"
721                return 1
722        fi
723}
724
725# Copiar carpeta de Interface
726function updateInterfaceAdm()
727{
728        local errcode=0
729
730        # Crear carpeta y copiar Interface
731        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
732        mv $INSTALL_TARGET/client/interfaceAdm $INSTALL_TARGET/client/Interface
733        rsync -irplt $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client
734        errcoce=$?
735        mv $INSTALL_TARGET/client/Interface $INSTALL_TARGET/client/interfaceAdm
736        if [ $errcode -ne 0 ]; then
737                echoAndLog "${FUNCNAME}(): error while updating admin interface"
738                exit 1
739        fi
740        echoAndLog "${FUNCNAME}(): Admin interface successfully updated"
741}
742
743# Crear documentación Doxygen para la consola web.
744function makeDoxygenFiles()
745{
746        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
747        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
748                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
749        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
750                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files"
751                return 1
752        fi
753        rm -fr "$INSTALL_TARGET/www/api"
754        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
755        rm -fr $INSTALL_TARGET/www/{man,perlmod,rtf}
756        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully"
757}
758
759
760# Crea la estructura base de la instalación de opengnsys
761function createDirs()
762{
763        # Crear estructura de directorios.
764        echoAndLog "${FUNCNAME}(): creating directory paths in ${INSTALL_TARGET}"
765        local dir MKNETDIR
766
767        mkdir -p ${INSTALL_TARGET}/{bin,doc,etc,lib,sbin,www}
768        mkdir -p ${INSTALL_TARGET}/{client,images/groups}
769        mkdir -p ${INSTALL_TARGET}/log/clients
770        ln -fs ${INSTALL_TARGET}/log /var/log/opengnsys
771        # Detectar directorio de instalación de TFTP.
772        if [ ! -L ${INSTALL_TARGET}/tftpboot ]; then
773                for dir in /var/lib/tftpboot /srv/tftp; do
774                        [ -d $dir ] && ln -fs $dir ${INSTALL_TARGET}/tftpboot
775                done
776        fi
777        mkdir -p $INSTALL_TARGET/tftpboot/{menu.lst,grub}/examples
778        if [ $? -ne 0 ]; then
779                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
780                return 1
781        fi
782        ! [ -f $INSTALL_TARGET/tftpboot/menu.lst/templates/00unknown ] && mv $INSTALL_TARGET/tftpboot/menu.lst/templates/* $INSTALL_TARGET/tftpboot/menu.lst/examples
783        ! [ -f $INSTALL_TARGET/tftpboot/grub/templates/10 ] && mv $INSTALL_TARGET/tftpboot/grub/templates/* $INSTALL_TARGET/tftpboot/grub/examples
784
785        # Preparar arranque en red con Grub.
786        for f in grub-mknetdir grub2-mknetdir; do
787                if which $f &>/dev/null; then MKNETDIR=$f; fi
788        done
789        $MKNETDIR --net-directory=$TFTPCFGDIR --subdir=grub
790
791        # Crear usuario ficticio.
792        if id -u $OPENGNSYS_CLIENTUSER &>/dev/null; then
793                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENTUSER\" is already created"
794        else
795                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
796                useradd $OPENGNSYS_CLIENTUSER 2>/dev/null
797                if [ $? -ne 0 ]; then
798                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
799                        return 1
800                fi
801        fi
802
803        # Mover el fichero de registro al directorio de logs.
804        echoAndLog "${FUNCNAME}(): moving update log file"
805        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
806        chmod 600 $LOG_FILE
807
808        echoAndLog "${FUNCNAME}(): directory paths created"
809        return 0
810}
811
812# Actualización incremental de la BD (versión actaul a actaul+1, hasta final-1 a final).
813function updateDatabase()
814{
815        local DBDIR="$WORKDIR/opengnsys/admin/Database"
816        local file FILES=""
817
818        echoAndLog "${FUNCNAME}(): looking for database updates"
819        pushd $DBDIR >/dev/null
820        # Bucle de actualización incremental desde versión actual a la final.
821        for file in $OPENGNSYS_DATABASE-*-*.sql; do
822                case "$file" in
823                        $OPENGNSYS_DATABASE-$OLDVERSION-$NEWVERSION.sql)
824                                # Actualización única de versión inicial y final.
825                                FILES="$FILES $file"
826                                break
827                                ;;
828                        $OPENGNSYS_DATABASE-*-postinst.sql)
829                                # Ignorar fichero específico de post-instalación.
830                                ;;
831                        $OPENGNSYS_DATABASE-$OLDVERSION-*.sql)
832                                # Actualización de versión n a n+1.
833                                FILES="$FILES $file"
834                                OLDVERSION="$(echo $file | cut -f3 -d-)"
835                                ;;
836                        $OPENGNSYS_DATABASE-*-$NEWVERSION.sql)
837                                # Última actualización de versión final-1 a final.
838                                if [ -n "$FILES" ]; then
839                                        FILES="$FILES $file"
840                                        break
841                                fi
842                                ;;
843                esac
844        done
845        # Aplicar posible actualización propia para la versión final.
846        file=$OPENGNSYS_DATABASE-$NEWVERSION.sql
847        if [ -n "$FILES" -o "$OLDVERSION" = "$NEWVERSION" -a -r $file ]; then
848                FILES="$FILES $file"
849        fi
850
851        popd >/dev/null
852        REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
853        if [ -n "$FILES" ]; then
854                for file in $FILES; do
855                        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $DBDIR/$file
856                done
857                echoAndLog "${FUNCNAME}(): database is update"
858        else
859                echoAndLog "${FUNCNAME}(): database unchanged"
860        fi
861}
862
863# Copia ficheros de configuración y ejecutables genéricos del servidor.
864function updateServerFiles()
865{
866        # No copiar ficheros del antiguo cliente Initrd
867        local SOURCES=( repoman/bin \
868                        server/bin \
869                        server/lib \
870                        admin/Sources/Services/ogAdmServerAux \
871                        admin/Sources/Services/ogAdmRepoAux \
872                        server/tftpboot \
873                        installer/opengnsys_uninstall.sh \
874                        installer/opengnsys_export.sh \
875                        installer/opengnsys_import.sh \
876                        doc )
877        local TARGETS=( bin \
878                        bin \
879                        lib \
880                        sbin/ogAdmServerAux \
881                        sbin/ogAdmRepoAux \
882                        tftpboot \
883                        lib/opengnsys_uninstall.sh \
884                        lib/opengnsys_export.sh \
885                        lib/opengnsys_import.sh \
886                        doc )
887
888        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
889                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
890                exit 1
891        fi
892
893        echoAndLog "${FUNCNAME}(): updating files in server directories"
894        pushd $WORKDIR/opengnsys >/dev/null
895        local i
896        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
897                if [ -d "$INSTALL_TARGET/${TARGETS[i]}" ]; then
898                        rsync -irplt "${SOURCES[i]}" $(dirname $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}"))
899                else
900                        rsync -irplt "${SOURCES[i]}" $(readlink -m "$INSTALL_TARGET/${TARGETS[i]}")
901                fi
902        done
903        popd >/dev/null
904        NEWFILES=""             # Ficheros de configuración que han cambiado de formato.
905        if grep -q 'pxelinux.0' /etc/dhcp*/dhcpd*.conf; then
906                echoAndLog "${FUNCNAME}(): updating DHCP files"
907                perl -pi -e 's/pxelinux.0/grldr/' /etc/dhcp*/dhcpd*.conf
908                service=$DHCPSERV; $STARTSERVICE
909                NEWFILES="/etc/dhcp*/dhcpd*.conf"
910        fi
911        if ! diff -q $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys 2>/dev/null; then
912                echoAndLog "${FUNCNAME}(): updating new init file"
913                backupFile /etc/init.d/opengnsys
914                cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
915                NEWFILES="$NEWFILES /etc/init.d/opengnsys"
916        fi
917        if ! diff -q $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default /etc/default/opengnsys >/dev/null; then
918                echoAndLog "${FUNCNAME}(): updating new default file"
919                backupFile /etc/default/opengnsys
920                # Buscar si hay nuevos parámetros.
921                local var valor
922                while IFS="=" read -e var valor; do
923                        [[ $var =~ ^# ]] || \
924                                grep -q "^$var=" /etc/default/opengnsys || \
925                                echo "$var=$valor" >> /etc/default/opengnsys
926                done < $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default
927                NEWFILES="$NEWFILES /etc/default/opengnsys"
928        fi
929        if egrep -q "(UrlMsg=.*msgbrowser.php)|(UrlMenu=http://)" $INSTALL_TARGET/client/etc/ogAdmClient.cfg 2>/dev/null; then
930                echoAndLog "${FUNCNAME}(): updating new client config file"
931                backupFile $INSTALL_TARGET/client/etc/ogAdmClient.cfg
932                perl -pi -e 's!UrlMsg=.*msgbrowser\.php!UrlMsg=http://localhost/cgi-bin/httpd-log\.sh!g; s!UrlMenu=http://!UrlMenu=https://!g' $INSTALL_TARGET/client/etc/ogAdmClient.cfg
933                NEWFILES="$NEWFILES $INSTALL_TARGET/client/etc/ogAdmClient.cfg"
934        fi
935
936        echoAndLog "${FUNCNAME}(): updating cron files"
937        [ ! -f /etc/cron.d/opengnsys ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
938        [ ! -f /etc/cron.d/torrentcreator ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
939        [ ! -f /etc/cron.d/torrenttracker ] && echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
940        [ ! -f /etc/cron.d/imagedelete ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
941        [ ! -f /etc/cron.d/ogagentqueue ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/ogagentqueue.cron ] && $INSTALL_TARGET/bin/ogagentqueue.cron" > /etc/cron.d/ogagentqueue
942        echoAndLog "${FUNCNAME}(): server files successfully updated"
943
944        # Se modifican los nombres de las plantilla PXE por compatibilidad con los equipos UEFI.
945        if [ -f $INSTALL_TARGET/tftpboot/menu.lst/templates/01 ]; then
946            BIOSPXEDIR="$INSTALL_TARGET/tftpboot/menu.lst/templates"
947            mv $BIOSPXEDIR/01 $BIOSPXEDIR/10
948            sed -i "s/\bMBR\b/1hd/" $BIOSPXEDIR/10
949            sed -i "s/\b1hd-1partition\b/1hd-1os/" $BIOSPXEDIR/11
950            sed -i "s/\b1hd-2partition\b/1hd-2os/" $BIOSPXEDIR/12
951        fi
952}
953
954####################################################################
955### Funciones de compilación de código fuente de servicios
956####################################################################
957
958# Mueve el fichero del nuevo servicio si es distinto al del directorio destino.
959function moveNewService()
960{
961        local service
962
963        # Recibe 2 parámetros: fichero origen y directorio destino.
964        [ $# == 2 ] || return 1
965        [ -f  $1 -a -d $2 ] || return 1
966
967        # Comparar los ficheros.
968        if ! diff -q $1 $2/$(basename $1) &>/dev/null; then
969                # Parar los servicios si fuese necesario.
970                [ -z "$NEWSERVICES" ] && service="opengnsys" $STOPSERVICE
971                # Nuevo servicio.
972                NEWSERVICES="$NEWSERVICES $(basename $1)"
973                # Mover el nuevo fichero de servicio
974                mv $1 $2
975        fi
976}
977
978
979# Recompilar y actualiza los serivicios y clientes.
980function compileServices()
981{
982        local hayErrores=0
983
984        # Compilar OpenGnsys Server
985        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Admin Server"
986        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
987        make && moveNewService ogAdmServer $INSTALL_TARGET/sbin
988        if [ $? -ne 0 ]; then
989                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
990                hayErrores=1
991        fi
992        popd
993        # Parar antiguo servicio de repositorio y añadir clave de acceso REST en su fichero de configuración.
994        pgrep ogAdmRepo > /dev/null && service="ogAdmRepo" $STOPSERVICE
995        sed -i -n -e "/^ApiToken=/!p" -e "$ a\ApiToken=$REPOKEY" $INSTALL_TARGET/etc/ogAdmRepo.cfg
996        sed -i -n -e "/^APITOKEN=/!p" -e "$ a\APITOKEN=$REPOKEY" $INSTALL_TARGET/etc/ogAdmServer.cfg
997        # Compilar OpenGnsys Agent
998        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Server Agent"
999        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
1000        make && moveNewService ogAdmAgent $INSTALL_TARGET/sbin
1001        if [ $? -ne 0 ]; then
1002                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Server Agent"
1003                hayErrores=1
1004        fi
1005        popd
1006
1007        # Compilar OpenGnsys Client
1008        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Client"
1009        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
1010        make && mv ogAdmClient $INSTALL_TARGET/client/bin
1011        if [ $? -ne 0 ]; then
1012                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Client"
1013                hayErrores=1
1014        fi
1015        popd
1016
1017        return $hayErrores
1018}
1019
1020
1021####################################################################
1022### Funciones instalacion cliente OpenGnsys
1023####################################################################
1024
1025# Actualizar cliente OpenGnsys
1026function updateClient()
1027{
1028        #local FILENAME=ogLive-precise-3.2.0-23-generic-r5159.iso       # 1.1.0-rc6 (32-bit)
1029        local FILENAME=ogLive-bionic-5.0.0-27-generic-amd64-r20190830.7208cc9.iso       # 1.1.1-rc5
1030        local SOURCEFILE=$DOWNLOADURL/$FILENAME
1031        local TARGETFILE=$(oglivecli config download-dir)/$FILENAME
1032        local SOURCELENGTH
1033        local TARGETLENGTH
1034        local OGINITRD
1035        local SAMBAPASS
1036
1037        # Comprobar si debe convertirse el antiguo cliente al nuevo formato ogLive.
1038        if oglivecli check | grep -q "oglivecli convert"; then
1039                echoAndLog "${FUNCNAME}(): Converting OpenGnsys Client to default ogLive"
1040                oglivecli convert
1041        fi
1042        # Comprobar si debe actualizarse el cliente.
1043        SOURCELENGTH=$(curl -sI $SOURCEFILE 2>&1 | awk '/Content-Length:/ {gsub("\r", ""); print $2}')
1044        TARGETLENGTH=$(stat -c "%s" $TARGETFILE 2>/dev/null)
1045        [ -z $TARGETLENGTH ] && TARGETLENGTH=0
1046        if [ "$SOURCELENGTH" != "$TARGETLENGTH" ]; then
1047                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
1048                oglivecli download $FILENAME
1049                if [ ! -s $TARGETFILE ]; then
1050                        errorAndLog "${FUNCNAME}(): Error downloading $FILENAME"
1051                        return 1
1052                fi
1053                # Actaulizar la imagen ISO del ogclient.
1054                echoAndLog "${FUNCNAME}(): Updatting ogLive client"
1055                oglivecli install $FILENAME
1056               
1057                INSTALLEDOGLIVE=${FILENAME%.*}
1058
1059                echoAndLog "${FUNCNAME}(): ogLive successfully updated"
1060        else
1061                # Si no existe, crear el fichero de claves de Rsync.
1062                if [ ! -f /etc/rsyncd.secrets ]; then
1063                        echoAndLog "${FUNCNAME}(): Restoring ogLive access key"
1064                        OGINITRD=$(oglivecli config install-dir)/$(jq -r ".oglive[.default].directory")/oginitrd.img
1065                        SAMBAPASS=$(gzip -dc $OGINITRD | \
1066                                    cpio -i --to-stdout scripts/ogfunctions 2>&1 | \
1067                                    grep "^[    ].*OPTIONS=" | \
1068                                    sed 's/\(.*\)pass=\(\w*\)\(.*\)/\2/')
1069                        echo -ne "$SAMBAPASS\n$SAMBAPASS\n" | setsmbpass
1070                else
1071                        echoAndLog "${FUNCNAME}(): ogLive is already updated"
1072                fi
1073                # Versión del ogLive instalado.
1074                echo "${FILENAME%.*}" > $INSTALL_TARGET/doc/veroglive.txt
1075        fi
1076}
1077
1078# Comprobar permisos y ficheros.
1079function checkFiles()
1080{
1081        local LOGROTATEDIR=/etc/logrotate.d
1082
1083        # Comprobar permisos adecuados.
1084        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
1085                echoAndLog "${FUNCNAME}(): Checking permissions"
1086                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENTUSER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" $INSTALL_TARGET/bin/checkperms
1087        fi
1088        # Eliminamos el fichero de estado del tracker porque es incompatible entre los distintos paquetes
1089        if [ -f /tmp/dstate ]; then
1090                echoAndLog "${FUNCNAME}(): Deleting unused files"
1091                rm -f /tmp/dstate
1092        fi
1093        # Crear nuevos ficheros de logrotate y borrar el fichero antiguo.
1094        if [ -d $LOGROTATEDIR ]; then
1095                rm -f $LOGROTATEDIR/opengnsys
1096                if [ ! -f $LOGROTATEDIR/opengnsysServer ]; then
1097                        echoAndLog "${FUNCNAME}(): Creating logrotate configuration file for server"
1098                        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
1099                                $WORKDIR/opengnsys/server/etc/logrotate.tmpl > $LOGROTATEDIR/opengnsysServer
1100                fi
1101                if [ ! -f $LOGROTATEDIR/opengnsysRepo ]; then
1102                        echoAndLog "${FUNCNAME}(): Creating logrotate configuration file for repository"
1103                        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
1104                                $WORKDIR/opengnsys/server/etc/logrotate.tmpl > $LOGROTATEDIR/opengnsysRepo
1105                fi
1106        fi
1107}
1108
1109# Resumen de actualización.
1110function updateSummary()
1111{
1112        # Actualizar fichero de versión y revisión.
1113        local VERSIONFILE REVISION
1114        VERSIONFILE="$INSTALL_TARGET/doc/VERSION.json"
1115        # Obtener revisión.
1116        if [ $REMOTE -eq 1 ]; then
1117                # Revisión: rAñoMesDía.Gitcommit (8 caracteres de fecha y 7 primeros de commit).
1118                REVISION=$(curl -s "$API_URL" | jq '"r" + (.commit.commit.committer.date | split("-") | join("")[:8]) + "." + (.commit.sha[:7])')
1119        else
1120                # Parámetro "release" del fichero JSON.
1121                REVISION=$(jq -r '.release' $PROGRAMDIR/../doc/VERSION.json 2>/dev/null)
1122        fi
1123        [ -f $VERSIONFILE ] || echo '{ "project": "OpenGnsys" }' > $VERSIONFILE
1124        jq ".release=$REVISION" $VERSIONFILE | sponge $VERSIONFILE
1125        VERSION="$(jq -r '[.project, .version, .codename, .release] | join(" ")' $VERSIONFILE 2>/dev/null)"
1126        # Borrar antiguo fichero de versión.
1127        rm -f "${VERSIONFILE/json/txt}"
1128
1129        echo
1130        echoAndLog "OpenGnsys Update Summary"
1131        echo       "========================"
1132        echoAndLog "Project version:                  $VERSION"
1133        echoAndLog "Update log file:                  $LOG_FILE"
1134        if [ -n "$NEWFILES" ]; then
1135                echoAndLog "Check new config files:           $(echo $NEWFILES)"
1136        fi
1137        if [ -n "$NEWSERVICES" ]; then
1138                echoAndLog "New compiled services:            $(echo $NEWSERVICES)"
1139                # Indicar si se debe reiniciar servicios manualmente o usando el Cron.
1140                [ -f /etc/default/opengnsys ] && source /etc/default/opengnsys
1141                if [ "$RUN_CRONJOB" == "no" ]; then
1142                        echoAndLog "        WARNING: you must to restart OpenGnsys services manually"
1143                else
1144                        echoAndLog "        New OpenGnsys services will be restarted by the cronjob"
1145                fi
1146        fi
1147        echoAndLog "Warnings:"
1148        echoAndLog " - You must to clear web browser cache before loading OpenGnsys page"
1149        echoAndLog " - Generated new key to access Repository REST API (file ogAdmRepo.cfg)"
1150        if [ -n "$INSTALLEDOGLIVE" ]; then
1151                echoAndLog " - Installed new ogLive Client: $INSTALLEDOGLIVE"
1152        fi
1153        if [ -n "$MYSQLCONFIG" ]; then
1154                echoAndLog " - MySQL must be reconfigured, run next code as DB root user and restart service:"
1155                echoAndLog "      $MYSQLCONFIG"
1156        fi
1157        echo
1158}
1159
1160
1161
1162#####################################################################
1163####### Proceso de actualización de OpenGnsys
1164#####################################################################
1165
1166
1167echoAndLog "OpenGnsys update begins at $(date)"
1168
1169pushd $WORKDIR
1170
1171# Comprobar si hay conexión y detectar parámetros de red por defecto.
1172checkNetworkConnection
1173if [ $? -ne 0 ]; then
1174        errorAndLog "Error connecting to server. Causes:"
1175        errorAndLog " - Network is unreachable, check device parameters"
1176        errorAndLog " - You are inside a private network, configure the proxy service"
1177        errorAndLog " - Server is temporally down, try again later"
1178        exit 1
1179fi
1180getNetworkSettings
1181
1182# Comprobar si se intanta actualizar a una versión anterior.
1183checkVersion
1184if [ $? -ne 0 ]; then
1185        errorAndLog "Cannot downgrade to an older version ($OLDVERSION to $NEWVERSION)"
1186        errorAndLog "You must to uninstall OpenGnsys and install desired release"
1187        exit 1
1188fi
1189
1190# Comprobar auto-actualización del programa.
1191if [ "$PROGRAMDIR" != "$INSTALL_TARGET/bin" ]; then
1192        checkAutoUpdate
1193        if [ $? -ne 0 ]; then
1194                echoAndLog "OpenGnsys updater has been overwritten"
1195                echoAndLog "Please, rerun this script"
1196                exit
1197        fi
1198fi
1199
1200# Detectar datos de auto-configuración del instalador.
1201autoConfigure
1202
1203# Instalar dependencias.
1204installDependencies ${DEPENDENCIES[*]}
1205if [ $? -ne 0 ]; then
1206        errorAndLog "Error: you must to install all needed dependencies"
1207        exit 1
1208fi
1209
1210# Arbol de directorios de OpenGnsys.
1211createDirs ${INSTALL_TARGET}
1212if [ $? -ne 0 ]; then
1213        errorAndLog "Error while creating directory paths"
1214        exit 1
1215fi
1216
1217# Si es necesario, descarga el repositorio de código en directorio temporal
1218if [ $REMOTE -eq 1 ]; then
1219        downloadCode $CODE_URL
1220        if [ $? -ne 0 ]; then
1221                errorAndLog "Error while getting code from repository"
1222                exit 1
1223        fi
1224else
1225        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
1226fi
1227
1228# Comprobar configuración de MySQL.
1229checkMysqlConfig $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD
1230
1231# Actualizar la BD.
1232updateDatabase
1233
1234# Actualizar ficheros complementarios del servidor
1235updateServerFiles
1236if [ $? -ne 0 ]; then
1237        errorAndLog "Error updating OpenGnsys Server files"
1238        exit 1
1239fi
1240
1241# Configurar Rsync.
1242rsyncConfigure
1243
1244# Actualizar ficheros del cliente.
1245updateClientFiles
1246createCerts
1247updateInterfaceAdm
1248
1249# Actualizar páqinas web.
1250apacheConfiguration
1251updateWebFiles
1252if [ $? -ne 0 ]; then
1253        errorAndLog "Error updating OpenGnsys Web Admin files"
1254        exit 1
1255fi
1256# Actaulizar ficheros descargables.
1257updateDownloadableFiles
1258# Generar páginas Doxygen para instalar en el web
1259makeDoxygenFiles
1260
1261# Recompilar y actualizar los servicios del sistema
1262compileServices
1263
1264# Actaulizar ficheros auxiliares del cliente
1265updateClient
1266if [ $? -ne 0 ]; then
1267        errorAndLog "Error updating client files"
1268        exit 1
1269fi
1270
1271# Comprobar permisos y ficheros.
1272checkFiles
1273
1274# Mostrar resumen de actualización.
1275updateSummary
1276
1277rm -rf $WORKDIR
1278echoAndLog "OpenGnsys update finished at $(date)"
1279
1280popd
1281
Note: See TracBrowser for help on using the repository browser.